struct VertexToPixel
{
    float4 Position     : POSITION;
    float lightvector : TEXCOORD0;
};

struct PixelToFrame
{
    float4 Color : COLOR0;
};

float4x4 xWorldViewProj : WorldViewProjection;
float4x4 xWorld : World;
float4 xLightPos: LightPos;

VertexToPixel TextureVertexShader( float4 inPos : POSITION)
{
    VertexToPixel Output = (VertexToPixel)0;
	
	Output.Position = mul(inPos,xWorldViewProj);
	
	float4 lightvector = (xLightPos - mul(inPos,xWorld));
	Output.lightvector = length(lightvector);
		
    return Output;    
}

PixelToFrame TexturePixelShader(VertexToPixel PSIn)
{
    PixelToFrame Output;
	Output.Color = float4(PSIn.lightvector + 1.0, PSIn.lightvector + 1.0, PSIn.lightvector + 1.0, 1.0);
    return Output;
    
}

technique Textured
{
    pass Pass0
    {        
        VertexShader = compile vs_3_0 TextureVertexShader();
        PixelShader = compile ps_3_0 TexturePixelShader();
    }
}